//=============================================================================
//
// file :         ABendingClass.h
//
// description :  Include for the ABendingClass root class.
//                This class is the singleton class for
//                the ABending device class.
//                It contains all properties and methods which the 
//                ABending requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: claudio $
//
// $Revision: 1.5 $
// $Date: 2012-06-05 13:11:00 $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/bending/src/ABendingClass.h,v $
// $Log: ABendingClass.h,v $
// Revision 1.5  2012-06-05 13:11:00  claudio
// added ExcitationSetPoint attribute
//
// Revision 1.4  2012-06-04 15:48:24  claudio
// read e setting separati
// piu' robusta gestione eccezzioni
//
// Revision 1.3  2012-02-29 13:00:42  claudio
// ticket 891:  aggiunti attributi per leggere minimi e massimi delle grandezze impostabili. Vengono ricalcolati quando cambia l'energia.
//
// Revision 1.2  2010/03/31 15:38:08  claudio
// added Kick in milliradians
//
// Revision 1.1  2010/02/23 15:45:19  claudio
// bending magnet model - first import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _ABENDINGCLASS_H
#define _ABENDINGCLASS_H

#include <tango.h>
#include <ABending.h>


namespace ABending_ns
{//=====================================
//	Define classes for attributes
//=====================================
class MaxKickAttrib: public Tango::Attr
{
public:
	MaxKickAttrib():Attr("MaxKick", Tango::DEV_DOUBLE, Tango::READ) {};
	~MaxKickAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_MaxKick(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_MaxKick_allowed(ty);}
};

class MinKickAttrib: public Tango::Attr
{
public:
	MinKickAttrib():Attr("MinKick", Tango::DEV_DOUBLE, Tango::READ) {};
	~MinKickAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_MinKick(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_MinKick_allowed(ty);}
};

class MaxMagnetEnergyAttrib: public Tango::Attr
{
public:
	MaxMagnetEnergyAttrib():Attr("MaxMagnetEnergy", Tango::DEV_DOUBLE, Tango::READ) {};
	~MaxMagnetEnergyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_MaxMagnetEnergy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_MaxMagnetEnergy_allowed(ty);}
};

class MinMagnetEnergyAttrib: public Tango::Attr
{
public:
	MinMagnetEnergyAttrib():Attr("MinMagnetEnergy", Tango::DEV_DOUBLE, Tango::READ) {};
	~MinMagnetEnergyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_MinMagnetEnergy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_MinMagnetEnergy_allowed(ty);}
};

class KickSetPointAttrib: public Tango::Attr
{
public:
	KickSetPointAttrib():Attr("KickSetPoint", Tango::DEV_DOUBLE, Tango::READ) {};
	~KickSetPointAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_KickSetPoint(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_KickSetPoint_allowed(ty);}
};

class KickAttrib: public Tango::Attr
{
public:
	KickAttrib():Attr("Kick", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~KickAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_Kick(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<ABending *>(dev))->write_Kick(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_Kick_allowed(ty);}
};

class EnergyAttrib: public Tango::Attr
{
public:
	EnergyAttrib():Attr("Energy", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~EnergyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_Energy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<ABending *>(dev))->write_Energy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_Energy_allowed(ty);}
};

class MagnetEnergySetPointAttrib: public Tango::Attr
{
public:
	MagnetEnergySetPointAttrib():Attr("MagnetEnergySetPoint", Tango::DEV_DOUBLE, Tango::READ) {};
	~MagnetEnergySetPointAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_MagnetEnergySetPoint(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_MagnetEnergySetPoint_allowed(ty);}
};

class MagnetEnergyAttrib: public Tango::Attr
{
public:
	MagnetEnergyAttrib():Attr("MagnetEnergy", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~MagnetEnergyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_MagnetEnergy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<ABending *>(dev))->write_MagnetEnergy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_MagnetEnergy_allowed(ty);}
};

class ExcitationSetPointAttrib: public Tango::Attr
{
public:
	ExcitationSetPointAttrib():Attr("ExcitationSetPoint", Tango::DEV_DOUBLE, Tango::READ) {};
	~ExcitationSetPointAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_ExcitationSetPoint(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_ExcitationSetPoint_allowed(ty);}
};

class ExcitationAttrib: public Tango::Attr
{
public:
	ExcitationAttrib():Attr("Excitation", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ExcitationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<ABending *>(dev))->read_Excitation(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<ABending *>(dev))->write_Excitation(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<ABending *>(dev))->is_Excitation_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
//
// The ABendingClass singleton definition
//

class
#ifdef _TG_WINDOWS_ 
	__declspec(dllexport)
#endif
	ABendingClass : public Tango::DeviceClass
{
public:
//	properties member data
	/**
	 *	The MySQL database user name
	 */
		string	dbName;
/**
 *	The MySQL database user name
 */
	string	dbUser;
/**
 *	The MySQL password
 */
	string	dbPassword;
/**
 *	The Database host name
 */
	string	dbHost;
/**
 *	minimum time interval between two reading of the excitation. In milliseconds.
The purpose is to limit the number of calls to the real hardware
 */
	Tango::DevULong	readInterval;
/**
 *	Specify which sign convention to use for horizaontally focussing elements
if True : focussing -> K>0 ( MAD, elegant,... )
if False : focussing -> K<0 ( vicky )
 */
	Tango::DevBoolean	madSignConvention;

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static ABendingClass *init(const char *);
	static ABendingClass *instance();
	~ABendingClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	ABendingClass(string &);
	static ABendingClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace ABending_ns

#endif // _ABENDINGCLASS_H
